#include "FileHandler.h"

int getNDigits(int number)
{
    int nDigits = 0;
    while (number != 0) {
        number /= 10;
        ++nDigits;
    }
    return nDigits;
}

char* createFileNameFromListSize(int listSize, char* fileExtension)
{
    char *fileName = NULL, *listSizeString;
    int fileNameSize = 0, digitsInSize;
    digitsInSize = getNDigits(listSize);
    //Original filename + size of number list + extension + \0
    fileNameSize = strlen(NUMBERFILE) + digitsInSize + strlen(fileExtension) + 1;

    listSizeString = (char*) malloc((sizeof(char)*digitsInSize)+1);
    sprintf(listSizeString, "%d", listSize);

    fileName = (char*) malloc(sizeof(char)*fileNameSize);
    strcpy(fileName, NUMBERFILE);
    strcat(fileName, listSizeString);
    strcat(fileName, fileExtension);
    return fileName;
}

void writeNumberListToTextFile(numberList_t numberList)
{
    FILE *pFile;
    char *fileName;

    fileName = createFileNameFromListSize(numberList.listSize, NUMBER_FILE_TEXT_EXTENSION);

    pFile = fopen(fileName, "w");

    if (pFile!=NULL)
    {
        for(int i = 0; i < numberList.listSize; ++i)
            fprintf(pFile, "%d\n", numberList.numbers[i]);
        fclose (pFile);
        return;
    }
    exit(EXIT_FAILURE);
}

void writeNumberListToBinaryFile(numberList_t numberList)
{
    FILE *pFile;
    char *fileName;

    fileName = createFileNameFromListSize(numberList.listSize, NUMBER_FILE_BINARY_EXTENSION);

    pFile = fopen(fileName, "wb");

    if (pFile!=NULL)
    {
        fwrite(numberList.numbers, sizeof(int), numberList.listSize, pFile);
        fclose (pFile);
        return;
    }
    exit(EXIT_FAILURE);
}
